Index: .bzrignore
===================================================================
--- .bzrignore	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ .bzrignore	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -269,2 +269,8 @@
 uspace/dist/srv/dhcp
 uspace/srv/net/dhcp/dhcp
+uspace/app/netspeed/netspeed
+uspace/dist/app/netspeed
+uspace/app/df/df
+uspace/dist/app/df
+uspace/app/download/download
+uspace/dist/app/download
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ boot/Makefile.common	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -174,4 +174,5 @@
 	$(USPACE_PATH)/app/dnscfg/dnscfg \
 	$(USPACE_PATH)/app/dnsres/dnsres \
+	$(USPACE_PATH)/app/download/download \
 	$(USPACE_PATH)/app/edit/edit \
 	$(USPACE_PATH)/app/inet/inet \
@@ -197,4 +198,5 @@
 	$(USPACE_PATH)/app/nettest3/nettest3 \
 	$(USPACE_PATH)/app/netecho/netecho \
+	$(USPACE_PATH)/app/netspeed/netspeed \
 	$(USPACE_PATH)/app/nterm/nterm \
 	$(USPACE_PATH)/app/ping/ping \
Index: kernel/arch/mips32/include/arch/asm.h
===================================================================
--- kernel/arch/mips32/include/arch/asm.h	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ kernel/arch/mips32/include/arch/asm.h	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -42,12 +42,5 @@
 NO_TRACE static inline void cpu_sleep(void)
 {
-	/*
-	 * Unfortunatelly most of the simulators do not support
-	 *
-	 * asm volatile (
-	 *     "wait"
-	 * );
-	 *
-	 */
+	asm volatile ("wait");
 }
 
Index: kernel/generic/src/debug/panic.c
===================================================================
--- kernel/generic/src/debug/panic.c	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ kernel/generic/src/debug/panic.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -96,7 +96,13 @@
 	printf("THE=%p: ", THE);
 	if (THE != NULL) {
-		printf("pe=%" PRIun " thr=%p task=%p cpu=%p as=%p"
+		printf("pd=%" PRIun " thread=%p task=%p cpu=%p as=%p"
 		    " magic=%#" PRIx32 "\n", THE->preemption_disabled,
 		    THE->thread, THE->task, THE->cpu, THE->as, THE->magic);
+		
+		if (THE->thread != NULL)
+			printf("thread=\"%s\"\n", THE->thread->name);
+		
+		if (THE->task != NULL)
+			printf("task=\"%s\"\n", THE->task->name);
 	} else
 		printf("invalid\n");
Index: kernel/generic/src/mm/frame.c
===================================================================
--- kernel/generic/src/mm/frame.c	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ kernel/generic/src/mm/frame.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -443,6 +443,5 @@
 NO_TRACE static void zone_mark_unavailable(zone_t *zone, size_t index)
 {
-	if (!(zone->flags & ZONE_AVAILABLE))
-		return;
+	ASSERT(zone->flags & ZONE_AVAILABLE);
 	
 	frame_t *frame = zone_get_frame(zone, index);
Index: tools/config.py
===================================================================
--- tools/config.py	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ tools/config.py	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -363,6 +363,7 @@
 def create_output(mkname, mcname, config, rules):
 	"Create output configuration"
-	
-	timestamp = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
+
+	timestamp_unix = int(time.time())
+	timestamp = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(timestamp_unix))
 	
 	sys.stderr.write("Fetching current revision identifier ... ")
@@ -423,4 +424,8 @@
 		outmc.write('#define REVISION %s\n' % revision)
 		defs += ' "-DREVISION=%s"' % revision
+	
+	outmk.write('TIMESTAMP_UNIX = %d\n' % timestamp_unix)
+	outmc.write('#define TIMESTAMP_UNIX %d\n' % timestamp_unix)
+	defs += ' "-DTIMESTAMP_UNIX=%d"\n' % timestamp_unix
 	
 	outmk.write('TIMESTAMP = %s\n' % timestamp)
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/Makefile	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -42,4 +42,5 @@
 	app/dnscfg \
 	app/dnsres \
+	app/download \
 	app/edit \
 	app/getterm \
@@ -70,4 +71,5 @@
 	app/vuhid \
 	app/netecho \
+	app/netspeed \
 	app/nettest1 \
 	app/nettest2 \
@@ -233,4 +235,5 @@
 	lib/gui \
 	lib/hound \
+	lib/http \
 	lib/softrend \
 	lib/draw \
@@ -238,4 +241,5 @@
 	lib/nic \
 	lib/ext4 \
+	lib/uri \
 	lib/usb \
 	lib/usbhost \
Index: uspace/Makefile.common
===================================================================
--- uspace/Makefile.common	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/Makefile.common	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -141,4 +141,7 @@
 LIBBITHENGE_PREFIX = $(LIB_PREFIX)/bithenge
 
+LIBHTTP_PREFIX = $(LIB_PREFIX)/http
+LIBURI_PREFIX = $(LIB_PREFIX)/uri
+
 ifeq ($(STATIC_NEEDED),y)
 	STATIC_BUILD = y
Index: uspace/app/df/df.c
===================================================================
--- uspace/app/df/df.c	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/app/df/df.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -50,5 +50,5 @@
 #define HEADER_TABLE_HR "Filesystem           Size           Used      Available Used%% Mounted on"
 
-#define PERCENTAGE(x, tot) ((unsigned long long) (100L * (x) / (tot)))
+#define PERCENTAGE(x, tot) (tot ? (100ULL * (x) / (tot)) : 0)
 #define FSBK_TO_BK(x, fsbk, bk) \
 	(((fsbk) != 0 && (fsbk) < (bk)) ? \
@@ -59,5 +59,5 @@
 static unsigned int human_readable;
 
-static int size_to_human_readable(char buf[], uint64_t bytes);
+static void size_to_human_readable(char *buf, uint64_t bytes);
 static void print_header(void);
 static void print_statfs(struct statfs *, char *, char *);
@@ -90,5 +90,6 @@
  
 		case ':':
-			fprintf(stderr, "Option -%c requires an operand\n", optopt);
+			fprintf(stderr, "Option -%c requires an operand\n",
+			    optopt);
 			errflg++;
 			break;
@@ -100,5 +101,6 @@
 
 		default:
-			fprintf(stderr, "Unknown error while parsing command line options.");
+			fprintf(stderr,
+			    "Unknown error while parsing command line options");
 			errflg++;
 			break;
@@ -107,5 +109,5 @@
 
 	if (optind > argc) {
-		fprintf(stderr, "Too many input parameter\n");
+		fprintf(stderr, "Too many input parameters\n");
 		errflg++;
 	}
@@ -118,4 +120,5 @@
 	LIST_INITIALIZE(mtab_list);
 	get_mtab_list(&mtab_list);
+
 	print_header();
 	list_foreach(mtab_list, link, mtab_ent_t, mtab_ent) {
@@ -123,24 +126,20 @@
 		print_statfs(&st, mtab_ent->fs_name, mtab_ent->mp);
 	}
+
 	putchar('\n');
 	return 0;
 }
 
-static int size_to_human_readable(char buf[], uint64_t bytes)
+static void size_to_human_readable(char *buf, uint64_t bytes)
 {
 	const char *units = "BkMGTPEZY";
 	int i = 0;
-	int limit;
-
-	limit = str_length(units);
+
 	while (bytes >= 1024) {
-		if (i >= limit) 
-			return -1;
 		bytes /= 1024;
 		i++;
 	}
-	snprintf(buf, 6, "%4llu%c", (unsigned long long)bytes, units[i]);
-
-	return 0;
+
+	snprintf(buf, 6, "%4llu%c", (unsigned long long) bytes, units[i]);
 }
 
@@ -151,4 +150,5 @@
 	else
 		printf(HEADER_TABLE, unit_size);
+
 	putchar('\n');
 }
@@ -156,27 +156,38 @@
 static void print_statfs(struct statfs *st, char *name, char *mountpoint)
 {
+	uint64_t const used_blocks = st->f_blocks - st->f_bfree;
+	unsigned const perc_used = PERCENTAGE(used_blocks, st->f_blocks);
+
 	printf("%10s", name);
 
 	if (human_readable) {
 		char tmp[1024];
+
+		/* Print size */
 		size_to_human_readable(tmp, st->f_blocks *  st->f_bsize);
-		printf(" %14s", tmp);                                                                  /* Size       */
-		size_to_human_readable(tmp, (st->f_blocks - st->f_bfree)  *  st->f_bsize);
-		printf(" %14s", tmp);                                                                  /* Used       */
+		printf(" %14s", tmp);
+
+		/* Number of used blocks */
+		size_to_human_readable(tmp, used_blocks  *  st->f_bsize);
+		printf(" %14s", tmp);
+
+		/* Number of available blocks */
 		size_to_human_readable(tmp, st->f_bfree *  st->f_bsize);
-		printf(" %14s", tmp);                                                                  /* Available  */
-		printf(" %4llu%% %s\n", 
-			(st->f_blocks)?PERCENTAGE(st->f_blocks - st->f_bfree, st->f_blocks):0L,        /* Used%      */
-			mountpoint                                                                     /* Mounted on */
-		);
-	}
-	else
-		printf(" %15llu %14llu %14llu %4llu%% %s\n", 
-			FSBK_TO_BK(st->f_blocks, st->f_bsize, unit_size),                              /* Blocks     */
-			FSBK_TO_BK(st->f_blocks - st->f_bfree, st->f_bsize, unit_size),                /* Used       */
-			FSBK_TO_BK(st->f_bfree, st->f_bsize, unit_size),                               /* Available  */
-			(st->f_blocks)?PERCENTAGE(st->f_blocks - st->f_bfree, st->f_blocks):0L,        /* Used%      */
-			mountpoint                                                                     /* Mounted on */
-		);
+		printf(" %14s", tmp);
+
+		/* Percentage of used blocks */
+		printf(" %4u%%", perc_used);
+
+		/* Mount point */
+		printf(" %s\n", mountpoint);
+	} else {
+		/* Blocks / Used blocks / Available blocks / Used% / Mounted on */
+		printf(" %15llu %14llu %14llu %4u%% %s\n", 
+		    FSBK_TO_BK(st->f_blocks, st->f_bsize, unit_size),
+		    FSBK_TO_BK(used_blocks, st->f_bsize, unit_size),
+		    FSBK_TO_BK(st->f_bfree, st->f_bsize, unit_size),
+		    perc_used,
+		    mountpoint);
+	}
 
 }
Index: uspace/app/download/Makefile
===================================================================
--- uspace/app/download/Makefile	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
+++ uspace/app/download/Makefile	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -0,0 +1,38 @@
+#
+# Copyright (c) 2013 Martin Sucha
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+LIBS = $(LIBHTTP_PREFIX)/libhttp.a $(LIBURI_PREFIX)/liburi.a
+EXTRA_CFLAGS = -I$(LIBHTTP_PREFIX) -I$(LIBURI_PREFIX)
+DEFS = -DRELEASE=$(RELEASE)
+BINARY = download
+
+SOURCES = \
+	main.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/download/main.c
===================================================================
--- uspace/app/download/main.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
+++ uspace/app/download/main.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -0,0 +1,219 @@
+/*
+ * Copyright (c) 2013 Martin Sucha
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup download
+ * @{
+ */
+
+/** @file
+ * Download a file from a HTTP server
+ *
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <str.h>
+#include <str_error.h>
+#include <task.h>
+#include <macros.h>
+
+#include <net/in.h>
+#include <net/inet.h>
+#include <net/socket.h>
+
+#include <http.h>
+#include <uri.h>
+
+#define NAME "download"
+#ifdef TIMESTAMP_UNIX
+#define VERSION STRING(RELEASE) "-" STRING(TIMESTAMP_UNIX)
+#else
+#define VERSION STRING(RELEASE)
+#endif
+#define USER_AGENT "HelenOS-" NAME "/" VERSION
+
+static void syntax_print(void)
+{
+	fprintf(stderr, "Usage: download <url>\n");
+	fprintf(stderr, "  This will write the data to stdout, so you may want\n");
+	fprintf(stderr, "  to redirect the output, e.g.\n");
+	fprintf(stderr, "\n");
+	fprintf(stderr, "    download http://helenos.org/ | to helenos.html\n\n");
+}
+
+int main(int argc, char *argv[])
+{
+	if (argc != 2) {
+		syntax_print();
+		return 2;
+	}
+	
+	uri_t *uri = uri_parse(argv[1]);
+	if (uri == NULL) {
+		fprintf(stderr, "Failed parsing URI\n");
+		return 2;
+	}
+	
+	if (!uri_validate(uri)) {
+		fprintf(stderr, "The URI is invalid\n");
+		return 2;
+	}
+	
+	/* TODO uri_normalize(uri) */
+	
+	if (str_cmp(uri->scheme, "http") != 0) {
+		fprintf(stderr, "Only http scheme is supported at the moment\n");
+		return 2;
+	}
+	
+	if (uri->host == NULL) {
+		fprintf(stderr, "host not set\n");
+		return 2;
+	}
+	
+	uint16_t port = 80;
+	if (uri->port != NULL) {
+		int rc = str_uint16_t(uri->port, NULL, 10, true, &port);
+		if (rc != EOK) {
+			fprintf(stderr, "Invalid port number: %s\n", uri->port);
+			return 2;
+		}
+	}
+	
+	const char *path = uri->path;
+	if (path == NULL || *path == 0)
+		path = "/";
+	char *server_path = NULL;
+	if (uri->query == NULL) {
+		server_path = str_dup(path);
+		if (server_path == NULL) {
+			fprintf(stderr, "Failed allocating path\n");
+			uri_destroy(uri);
+			return 3;
+		}
+	}
+	else {
+		int rc = asprintf(&server_path, "%s?%s", path, uri->query);
+		if (rc < 0) {
+			fprintf(stderr, "Failed allocating path\n");
+			uri_destroy(uri);
+			return 3;
+		}
+	}
+	
+	http_request_t *req = http_request_create("GET", server_path);
+	free(server_path);
+	if (req == NULL) {
+		fprintf(stderr, "Failed creating request\n");
+		uri_destroy(uri);
+		free(server_path);
+		return 3;
+	}
+	
+	http_header_t *header_host = http_header_create("Host", uri->host);
+	if (header_host == NULL) {
+		fprintf(stderr, "Failed creating Host header\n");
+		uri_destroy(uri);
+		free(server_path);
+		return 3;
+	}
+	list_append(&header_host->link, &req->headers);
+	
+	http_header_t *header_ua = http_header_create("User-Agent", USER_AGENT);
+	if (header_ua == NULL) {
+		fprintf(stderr, "Failed creating User-Agent header\n");
+		uri_destroy(uri);
+		free(server_path);
+		return 3;
+	}
+	list_append(&header_ua->link, &req->headers);
+	
+	http_t *http = http_create(uri->host, port);
+	if (http == NULL) {
+		uri_destroy(uri);
+		free(server_path);
+		fprintf(stderr, "Failed creating HTTP object\n");
+		return 3;
+	}
+	
+	int rc = http_connect(http);
+	if (rc != EOK) {
+		fprintf(stderr, "Failed connecting: %s\n", str_error(rc));
+		uri_destroy(uri);
+		free(server_path);
+		return rc;
+	}
+	
+	rc = http_send_request(http, req);
+	if (rc != EOK) {
+		fprintf(stderr, "Failed sending request: %s\n", str_error(rc));
+		uri_destroy(uri);
+		free(server_path);
+		return rc;
+	}
+	
+	http_response_t *response = NULL;
+	rc = http_receive_response(http, &response);
+	if (rc != EOK) {
+		fprintf(stderr, "Failed receiving response: %s\n", str_error(rc));
+		uri_destroy(uri);
+		free(server_path);
+		return rc;
+	}
+	
+	if (response->status != 200) {
+		fprintf(stderr, "Server returned status %d %s\n", response->status,
+		    response->message);
+	}
+	else {
+		size_t buf_size = 4096;
+		void *buf = malloc(buf_size);
+		if (buf == NULL) {
+			fprintf(stderr, "Failed allocating buffer\n)");
+			uri_destroy(uri);
+			free(server_path);
+			return ENOMEM;
+		}
+		
+		int body_size;
+		while ((body_size = http_receive_body(http, buf, buf_size)) > 0) {
+			fwrite(buf, 1, body_size, stdout);
+		}
+		
+		if (body_size != 0) {
+			fprintf(stderr, "Failed receiving body: %s", str_error(body_size));
+		}
+	}
+	
+	uri_destroy(uri);
+	free(server_path);
+	return EOK;
+}
+
+/** @}
+ */
Index: uspace/app/netspeed/Makefile
===================================================================
--- uspace/app/netspeed/Makefile	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
+++ uspace/app/netspeed/Makefile	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -0,0 +1,37 @@
+#
+# Copyright (c) 2013 Martin Sucha
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+LIBS = 
+EXTRA_CFLAGS = 
+BINARY = netspeed
+
+SOURCES = \
+	netspeed.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/netspeed/netspeed.c
===================================================================
--- uspace/app/netspeed/netspeed.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
+++ uspace/app/netspeed/netspeed.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -0,0 +1,277 @@
+/*
+ * Copyright (c) 2013 Martin Sucha
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup netspeed
+ * @{
+ */
+
+/** @file
+ * Network speed measurement (iperf counterpart)
+ *
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <str.h>
+#include <str_error.h>
+#include <task.h>
+
+#include <net/in.h>
+#include <net/inet.h>
+#include <net/socket.h>
+
+#define NAME "netspeed"
+
+static int server(sock_type_t sock_type, unsigned port, void *buf, size_t bufsize)
+{
+	struct sockaddr_in addr;
+	
+	addr.sin_family = AF_INET;
+	addr.sin_port = htons(port);
+	
+	int rc = inet_pton(AF_INET, "127.0.0.1", (void *)
+	    &addr.sin_addr.s_addr);
+	if (rc != EOK) {
+		fprintf(stderr, "inet_pton failed: %s\n", str_error(rc));
+		return rc;
+	}
+
+	int listen_sd = socket(PF_INET, sock_type, 0);
+	if (listen_sd < 0) {
+		fprintf(stderr, "socket failed: %s\n", str_error(rc));
+		return rc;
+	}
+	
+	rc = bind(listen_sd, (struct sockaddr *) &addr, sizeof(addr));
+	if (rc != EOK) {
+		fprintf(stderr, "bind failed: %s\n", str_error(rc));
+		closesocket(listen_sd);
+		return rc;
+	}
+	
+	rc = listen(listen_sd, 2);
+	if (rc != EOK) {
+		fprintf(stderr, "listen failed: %s\n", str_error(rc));
+		closesocket(listen_sd);
+		return rc;
+	}
+	
+	int conn_sd;
+	struct sockaddr_in raddr;
+	socklen_t raddr_len = sizeof(raddr);
+	if (sock_type == SOCK_STREAM) {
+		conn_sd = accept(listen_sd, (struct sockaddr *) &raddr,
+		    &raddr_len);
+		if (conn_sd < 0) {
+			fprintf(stderr, "accept failed: %s\n", str_error(conn_sd));
+			closesocket(listen_sd);
+			return conn_sd;
+		}
+	} else {
+		conn_sd = listen_sd;
+	}
+	
+	while (true) {
+		rc = recvfrom(conn_sd, buf, bufsize, 0, (struct sockaddr *) &raddr,
+		    &raddr_len);
+		if (rc <= 0) {
+			if (rc < 0)
+				fprintf(stderr, "recvfrom failed: %s\n", str_error(rc));
+			break;
+		}
+	}
+	
+	if (sock_type == SOCK_STREAM)
+		closesocket(conn_sd);
+	closesocket(listen_sd);
+	
+	return rc;
+}
+
+static int client(sock_type_t sock_type, const char *address, unsigned port,
+    unsigned long count, char *buf, size_t bufsize)
+{
+	struct sockaddr_in addr;
+	
+	addr.sin_family = AF_INET;
+	addr.sin_port = htons(port);
+	
+	int rc = inet_pton(AF_INET, address, (void *) &addr.sin_addr.s_addr);
+	if (rc != EOK) {
+		fprintf(stderr, "inet_pton failed: %s\n", str_error(rc));
+		return rc;
+	}
+	
+	int conn_sd = socket(PF_INET, sock_type, 0);
+	if (conn_sd < 0) {
+		fprintf(stderr, "socket failed: %s\n", str_error(rc));
+		return rc;
+	}
+	
+	if (sock_type == SOCK_STREAM) {
+		rc = connect(conn_sd, (struct sockaddr *) &addr, sizeof(addr));
+		if (rc != EOK) {
+			fprintf(stderr, "connect failed: %s\n", str_error(rc));
+			closesocket(conn_sd);
+			return rc;
+		}
+	}
+	
+	for (size_t pos = 0; pos < bufsize; pos++) {
+		buf[pos] = '0' + (pos % 10);
+	}
+	
+	for (unsigned long i = 0; i < count; i++) {
+		if (sock_type == SOCK_STREAM) {
+			rc = send(conn_sd, buf, bufsize, 0);
+		} else {
+			rc = sendto(conn_sd, buf, bufsize, 0,
+			    (struct sockaddr *) &addr, sizeof(addr));
+		}
+		if (rc != EOK) {
+			fprintf(stderr, "send failed: %s\n", str_error(rc));
+			break;
+		}
+	}
+	
+	closesocket(conn_sd);
+	return rc;
+}
+
+static void syntax_print(void)
+{
+	fprintf(stderr, "Usage: netspeed <tcp|udp> server [port] <buffer size>\n");
+	fprintf(stderr, "       netspeed <tcp|udp> client <ip> <port> <count> <buffer size>\n");
+}
+
+int main(int argc, char *argv[])
+{
+	if (argc < 3) {
+		syntax_print();
+		return 2;
+	}
+	
+	sock_type_t sock_type;
+	if (str_cmp(argv[1], "tcp") == 0) {
+		sock_type = SOCK_STREAM;
+	} else if (str_cmp(argv[1], "udp") == 0) {
+		sock_type = SOCK_DGRAM;
+	} else {
+		fprintf(stderr, "Invalid socket type\n");
+		syntax_print();
+		return 1;
+	}
+	
+	char *endptr;
+	int arg = 3;
+	unsigned long port = 5001;
+	const char *address;
+	bool is_server;
+	unsigned long count = 0;
+	
+	if (str_cmp(argv[2], "server") == 0) {
+		is_server = true;
+		if (argc < 4) {
+			syntax_print();
+			return 2;
+		}
+		if (argc > 4) {
+			port = strtoul(argv[3], &endptr, 0);
+			if (*endptr != 0) {
+				fprintf(stderr, "Invalid port number\n");
+				syntax_print();
+				return 1;
+			}
+			arg = 4;
+		}
+	}
+	else if (str_cmp(argv[2], "client") == 0) {
+		is_server = false;
+		if (argc < 6) {
+			syntax_print();
+			return 2;
+		}
+		address = argv[3];
+		port = strtoul(argv[4], &endptr, 0);
+		if (*endptr != 0) {
+			fprintf(stderr, "Invalid port number\n");
+			syntax_print();
+			return 1;
+		}
+		
+		count = strtoul(argv[5], &endptr, 0);
+		if (*endptr != 0) {
+			fprintf(stderr, "Invalid count\n");
+			syntax_print();
+			return 1;
+		}
+		
+		arg = 6;
+	}
+	else {
+		fprintf(stderr, "Invalid client/server mode\n");
+		syntax_print();
+		return 2;
+	}
+	
+	if (argc < arg + 1) {
+		syntax_print();
+		return 2;
+	}
+	
+	unsigned long bufsize = strtoul(argv[arg], &endptr, 0);
+	if (*endptr != 0 || bufsize == 0) {
+		fprintf(stderr, "Invalid buffer size\n");
+		syntax_print();
+		return 1;
+	}
+	
+	void *buf = malloc(bufsize);
+	if (buf == NULL) {
+		fprintf(stderr, "Cannot allocate buffer\n");
+		return ENOMEM;
+	}
+	
+	int rc = EOK;
+	if (is_server) {
+		rc = server(sock_type, port, buf, bufsize);
+		if (rc != EOK)
+			fprintf(stderr, "Server failed: %s\n", str_error(rc));
+	} else {
+		rc = client(sock_type, address, port, count, buf, bufsize);
+		if (rc != EOK)
+			fprintf(stderr, "Client failed: %s\n", str_error(rc));
+	}
+	
+	free(buf);
+
+	return rc;
+}
+
+/** @}
+ */
Index: uspace/app/wavplay/dplay.c
===================================================================
--- uspace/app/wavplay/dplay.c	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/app/wavplay/dplay.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -151,5 +151,6 @@
 	    device_event_callback, pb);
 	if (ret != EOK) {
-		printf("Failed to register event callback.\n");
+		printf("Failed to register event callback: %s.\n",
+		    str_error(ret));
 		return;
 	}
@@ -285,5 +286,6 @@
 			    pb->f.sample_format);
 			if (ret != EOK) {
-				printf("Failed to start playback\n");
+				printf("Failed to start playback: %s\n",
+				    str_error(ret));
 				return;
 			}
@@ -291,5 +293,6 @@
 			ret = audio_pcm_get_buffer_pos(pb->device, &pos);
 			if (ret != EOK) {
-				printf("Failed to update position indicator\n");
+				printf("Failed to update position indicator "
+				   "%s\n", str_error(ret));
 			}
 		}
@@ -308,5 +311,6 @@
 		const int ret = audio_pcm_get_buffer_pos(pb->device, &pos);
 		if (ret != EOK) {
-			printf("Failed to update position indicator\n");
+			printf("Failed to update position indicator %s\n",
+			    str_error(ret));
 		}
 		getuptime(&time);
@@ -350,5 +354,5 @@
 	ret = audio_pcm_get_info_str(session, &info);
 	if (ret != EOK) {
-		printf("Failed to get PCM info.\n");
+		printf("Failed to get PCM info: %s.\n", str_error(ret));
 		goto close_session;
 	}
Index: uspace/app/wavplay/drec.c
===================================================================
--- uspace/app/wavplay/drec.c	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/app/wavplay/drec.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -213,7 +213,6 @@
 	wave_header_t header;
 	fseek(rec.file, sizeof(header), SEEK_SET);
-	const char *error;
-	if (ret != EOK) {
-		printf("Error parsing wav header: %s.\n", error);
+	if (ret != EOK) {
+		printf("Error parsing wav header\n");
 		goto cleanup;
 	}
Index: uspace/app/wavplay/main.c
===================================================================
--- uspace/app/wavplay/main.c	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/app/wavplay/main.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -79,8 +79,12 @@
 	    &format.sampling_rate, &format.sample_format, &error);
 	if (ret != EOK) {
-		printf("Error parsing wav header: %s.\n", error);
+		printf("Error parsing `%s' wav header: %s.\n", filename, error);
 		fclose(source);
 		return EINVAL;
 	}
+
+	printf("File `%s' format: %u channel(s), %uHz, %s.\n", filename,
+	    format.channels, format.sampling_rate,
+	    pcm_sample_format_str(format.sample_format));
 
 	/* Allocate buffer and create new context */
@@ -136,8 +140,11 @@
 	    &format.sampling_rate, &format.sample_format, &error);
 	if (ret != EOK) {
-		printf("Error parsing wav header: %s.\n", error);
+		printf("Error parsing `%s' wav header: %s.\n", filename, error);
 		fclose(source);
 		return EINVAL;
 	}
+	printf("File `%s' format: %u channel(s), %uHz, %s.\n", filename,
+	    format.channels, format.sampling_rate,
+	    pcm_sample_format_str(format.sample_format));
 
 	/* Connect new playback context */
Index: uspace/app/wavplay/wave.c
===================================================================
--- uspace/app/wavplay/wave.c	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/app/wavplay/wave.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -81,8 +81,10 @@
 	}
 
-	if (uint16_t_le2host(header->subchunk1_size) != PCM_SUBCHUNK1_SIZE) {
+	if (uint32_t_le2host(header->subchunk1_size) != PCM_SUBCHUNK1_SIZE) {
+		//TODO subchunk 1 sizes other than 16 are allowed ( 18, 40)
+		//http://www-mmsp.ece.mcgill.ca/documents/AudioFormats/WAVE/WAVE.html
 		if (error)
 			*error = "invalid subchunk1 size";
-		return EINVAL;
+//		return EINVAL;
 	}
 
@@ -94,10 +96,14 @@
 
 	if (str_lcmp(header->subchunk2_id, SUBCHUNK2_ID, 4) != 0) {
+		//TODO basedd on subchunk1 size, we might be reading wrong
+		//offset
 		if (error)
 			*error = "invalid subchunk2 id";
-		return EINVAL;
+//		return EINVAL;
 	}
 
 
+	//TODO data and data_size are incorrect in extended wav formats
+	//pcm params are OK
 	if (data)
 		*data = header->data;
